commit fda16457fbba6a11abdb09370ce21ea09f9e64f7
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 14 15:32:48 2025 +0000

    proxy-protocol module

diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index 9f26eff0f..ff733b490 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -557,7 +557,7 @@ OBJ_EXIM = acl.o atrn.o base64.o child.o crypt16.o daemon.o dbfn.o debug.o \
 	deliver.o directory.o dns.o drtables.o enq.o exim.o expand.o \
         filtertest.o globals.o dnsbl.o hash.o \
         header.o host.o host_address.o ip.o log.o lss.o match.o md5.o moan.o \
-        os.o parse.o priv.o proxy.o queue.o \
+        os.o parse.o priv.o queue.o \
         rda.o readconf.o receive.o retry.o rewrite.o rfc2047.o regex_cache.o \
         route.o search.o smtp_in.o smtp_out.o spool_in.o spool_out.o \
         std-crypto.o store.o string.o tls.o tod.o transport.o tree.o verify.o \
@@ -895,7 +895,6 @@ moan.o:          $(HDRS) moan.c
 os.o:            $(HDRS) $(OS_C_INCLUDES) os.c
 parse.o:         $(HDRS) parse.c
 priv.o:          $(HDRS) priv.c
-proxy.o:         $(HDRS) proxy.c
 queue.o:         $(HDRS) queue.c
 rda.o:           $(HDRS) rda.c
 readconf.o:      $(HDRS) readconf.c
diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index 9a7351482..84a8abbb2 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -332,7 +332,7 @@ done <<-END
  routers    ROUTER	ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
  transports TRANSPORT	APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
  auths	    AUTH	CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
- miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SOCKS SPF SPF_PERL XCLIENT
+ miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL PROXY RADIUS _SIEVE_FILTER SOCKS SPF SPF_PERL XCLIENT
 END
 
 # See if there is a definition of EXIM_PERL in what we have built so far.
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 642cd7302..5219d3dbc 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -106,6 +106,7 @@ for f in dummy.c \
 	exim_filter.c exim_filter_api.h \
 	pam.c pam_api.h \
 	perl.c perl_api.h \
+	proxy.c proxy_api.h \
 	radius.c radius_api.h \
 	sieve_filter.c sieve_filter_api.h \
 	socks.c socks_api.h \
@@ -139,7 +140,7 @@ for f in blob.h dbfunctions.h exim.h functions.h globals.h \
   debug.c deliver.c directory.c dns.c dnsbl.c drtables.c dummies.c enq.c \
   exim.c exim_dbmbuild.c exim_dbutil.c exim_lock.c expand.c filtertest.c \
   globals.c hash.c header.c host.c host_address.c ip.c log.c lss.c match.c \
-  md5.c moan.c parse.c priv.c proxy.c queue.c rda.c readconf.c receive.c \
+  md5.c moan.c parse.c priv.c queue.c rda.c readconf.c receive.c \
   retry.c rewrite.c regex_cache.c rfc2047.c route.c search.c setenv.c \
   environment.c smtp_in.c smtp_out.c spool_in.c spool_out.c std-crypto.c \
   store.c string.c tls.c tlscert-gnu.c tlscert-openssl.c tls-cipher-stdname.c \
diff --git a/src/src/EDITME b/src/src/EDITME
index 9e5b25029..8977f624b 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -1137,7 +1137,7 @@ ZCAT_COMMAND=/usr/bin/zcat
 # SUPPORT_SOCKS=yes
 
 # If you may want to use inbound (server-side) proxying, using Proxy Protocol,
-# uncomment the line below.
+# uncomment the line below.  To build as a dynamic module set it to 2.
 
 # SUPPORT_PROXY=yes
 
diff --git a/src/src/drtables.c b/src/src/drtables.c
index 4df612c65..833c352c0 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -504,6 +504,9 @@ extern misc_module_info pam_module_info;
 #if defined(EXIM_PERL) && (!defined(SUPPORT_PERL) || SUPPORT_PERL!=2)
 extern misc_module_info perl_module_info;
 #endif
+#if defined(SUPPORT_PROXY) && SUPPORT_PROXY!=2
+extern misc_module_info proxy_module_info;
+#endif
 #if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
 extern misc_module_info radius_module_info;
 #endif
@@ -553,6 +556,9 @@ onetime = TRUE;
 #if defined(EXIM_PERL) && (!defined(SUPPORT_PERL) || SUPPORT_PERL!=2)
   misc_mod_add(&perl_module_info);
 #endif
+#if defined(SUPPORT_PROXY) && SUPPORT_PROXY!=2
+  misc_mod_add(&proxy_module_info);
+#endif
 #if !defined(DISABLE_EXIM_FILTER) && (!defined(SUPPORT_EXIM_FILTER) || SUPPORT_EXIM_FILTER!=2)
   misc_mod_add(&exim_filter_module_info);
 #endif
diff --git a/src/src/exim.h b/src/src/exim.h
index 7b4270cad..70911b0f8 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -567,6 +567,9 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #ifdef EXIM_PERL
 # include "miscmods/perl_api.h"
 #endif
+#ifdef SUPPORT_PROXY
+# include "miscmods/proxy_api.h"
+#endif
 #ifdef SUPPORT_SOCKS
 # include "miscmods/socks_api.h"
 #endif
diff --git a/src/src/functions.h b/src/src/functions.h
index f07799321..b48103922 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -407,10 +407,6 @@ const misc_module_info * perl_startup(const uschar *);
 
 extern void priv_drop_temp(const uid_t, const gid_t);
 extern void priv_restore(void);
-#ifdef SUPPORT_PROXY
-extern BOOL	proxy_protocol_host(void);
-extern void	proxy_protocol_setup(void);
-#endif
 
 extern BOOL    queue_action(const uschar *, int, const uschar **, int, int);
 extern void    queue_check_only(void);
diff --git a/src/src/globals.c b/src/src/globals.c
index 6d2b27227..2d1354236 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -286,15 +286,15 @@ struct global_flags f =
 	.parse_allow_group      = FALSE,
 	.parse_found_group      = FALSE,
 	.pipelining_enable      = TRUE,
-#if defined(SUPPORT_PROXY) || defined(SUPPORT_SOCKS)
-	.proxy_session_failed   = FALSE,
-#endif
 
 	.queue_2stage           = FALSE,
 	.queue_only_policy      = FALSE,
 	.queue_run_local        = FALSE,
 	.queue_running          = FALSE,
 	.queue_smtp             = FALSE,
+#if defined(SUPPORT_PROXY)
+	.quit_cmd_only		= FALSE,
+#endif
 
 	.really_exim            = TRUE,
 	.receive_call_bombout   = FALSE,
diff --git a/src/src/globals.h b/src/src/globals.h
index 977107f58..52c46f169 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -256,15 +256,15 @@ extern struct global_flags {
  BOOL   parse_allow_group		:1; /* Allow group syntax */
  BOOL   parse_found_group		:1; /* In the middle of a group */
  BOOL   pipelining_enable		:1; /* As it says */
-#if defined(SUPPORT_PROXY) || defined(SUPPORT_SOCKS)
- BOOL   proxy_session_failed		:1; /* TRUE if required proxy negotiation failed */
-#endif
 
  BOOL   queue_2stage			:1; /* Run queue in 2-stage manner */
  BOOL   queue_only_policy		:1; /* ACL or local_scan wants queue_only */
  BOOL   queue_run_local			:1; /* Local deliveries only in queue run */
  BOOL   queue_running			:1; /* TRUE for queue running process and */
  BOOL   queue_smtp			:1; /* Disable all immediate SMTP (-odqs)*/
+#ifdef SUPPORT_PROXY
+ BOOL   quit_cmd_only			:1; /* TRUE if required proxy negotiation failed */
+#endif
 
  BOOL   really_exim			:1; /* FALSE in utilities */
  BOOL   receive_call_bombout		:1; /* Flag for crashing log */
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index f731088ba..1076c6daf 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -46,6 +46,7 @@ dummy.o:			dummy.c
 exim_filter.o	exim_filter.so:	$(HDRS) exim_filter.c
 pam.o   	pam.so:		$(HDRS) pam.c
 perl.o		perl.so:       	$(HDRS) perl.c
+proxy.o		proxy.so:	$(HDRS) proxy_api.h proxy.c
 radius.o	radius.so:	$(HDRS) radius.c
 sieve_filter.o	sieve_filter.so: $(HDRS) sieve_filter.c
 socks.o		socks.so:	$(HDRS) socks_api.h ../transports/smtp.h socks.c
diff --git a/src/src/proxy.c b/src/src/miscmods/proxy.c
similarity index 95%
rename from src/src/proxy.c
rename to src/src/miscmods/proxy.c
index c8230b009..320b57ea8 100644
--- a/src/src/proxy.c
+++ b/src/src/miscmods/proxy.c
@@ -11,9 +11,17 @@
 *            Proxy-Protocol support             *
 ************************************************/
 
-#include "exim.h"
+#include "../exim.h"
 
 #ifdef SUPPORT_PROXY
+
+
+static void
+command_timeout_handler(int sig)
+{
+had_command_timeout = sig;
+}
+
 /*************************************************
 *       Check if host is required proxy host     *
 *************************************************/
@@ -25,7 +33,7 @@ Arguments: none
 Returns:   boolean for Proxy Protocol needed
 */
 
-BOOL
+static BOOL
 proxy_protocol_host(void)
 {
 if (  sender_host_address
@@ -34,6 +42,7 @@ if (  sender_host_address
   {
   DEBUG(D_receive)
     debug_printf("Detected proxy protocol configured host\n");
+  /* having this set when we could still fail is ugly */
   proxy_session = TRUE;
   }
 return proxy_session;
@@ -114,6 +123,7 @@ debug_printf("PROXY<<%3.*H\n", (int)(end - start), buf + start);
 }
 
 
+/*API*/
 /*************************************************
 *         Setup host for proxy protocol          *
 *************************************************/
@@ -123,11 +133,11 @@ so exit with an error if do not find the exact required pieces. This
 includes an incorrect number of spaces separating args.
 
 Arguments: none
-Returns:   Boolean success
+Returns:   TRUE iff success
 */
 
-void
-proxy_protocol_setup(void)
+static BOOL
+proxy_protocol(void)
 {
 union {
   struct {
@@ -201,6 +211,10 @@ const char v2sig[12] = "\x0D\x0A\x0D\x0A\x00\x0D\x0A\x51\x55\x49\x54\x0A";
 uschar * iptype;  /* To display debug info */
 BOOL yield = FALSE;
 
+if (!proxy_protocol_host())
+  return TRUE;
+
+os_non_restarting_signal(SIGALRM, command_timeout_handler);
 ALARM(proxy_protocol_timeout);
 
 do
@@ -496,6 +510,8 @@ done:
 should cause a synchronization failure */
 
 proxyfail:
+
+  ALARM(0);
   DEBUG(D_receive) if (had_command_timeout)
     debug_printf("Timeout while reading proxy header\n");
 
@@ -506,15 +522,29 @@ proxyfail:
     host_build_sender_fullhost();
     }
   else
-    {
-    f.proxy_session_failed = TRUE;
     DEBUG(D_receive)
       debug_printf("Failure to extract proxied host, only QUIT allowed\n");
-    }
 
-ALARM(0);
-return;
+return yield;
 }
+
+
+/******************************************************************************/
+/* Module API */
+
+static void * proxy_functions[] = {
+  [PROXY_PROTO_START] =	(void *) proxy_protocol,
+};
+
+misc_module_info proxy_module_info =
+{
+  .name =		US"proxy",
+# ifdef DYNLOOKUP
+  .dyn_magic =		MISC_MODULE_MAGIC,
+# endif
+  .functions =		proxy_functions,
+  .functions_count =	nelem(proxy_functions),
+};
 #endif	/*SUPPORT_PROXY*/
 
 /* vi: aw ai sw=2
diff --git a/src/src/miscmods/proxy_api.h b/src/src/miscmods/proxy_api.h
new file mode 100644
index 000000000..4cd57908c
--- /dev/null
+++ b/src/src/miscmods/proxy_api.h
@@ -0,0 +1,14 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+/* API definitions for the proxy-protocol module */
+
+
+/* Function table entry numbers */
+
+#define	PROXY_PROTO_START	0
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index 222fc5b93..3ffb6fe8b 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -1308,8 +1308,8 @@ if required. */
 for (smtp_cmd_list * p = cmd_list; p < cmd_list + nelem(cmd_list); p++)
   {
 #ifdef SUPPORT_PROXY
-  /* Only allow QUIT command if Proxy Protocol parsing failed */
-  if (proxy_session && f.proxy_session_failed && p->cmd != QUIT_CMD)
+  /* If Proxy Protocol parsing failed, only allow QUIT command */
+  if (f.quit_cmd_only && p->cmd != QUIT_CMD)
     continue;
 #endif
   if (  p->len
@@ -1363,8 +1363,8 @@ for (smtp_cmd_list * p = cmd_list; p < cmd_list + nelem(cmd_list); p++)
   }
 
 #ifdef SUPPORT_PROXY
-/* Only allow QUIT command if Proxy Protocol parsing failed */
-if (proxy_session && f.proxy_session_failed)
+/* If Proxy Protocol parsing failed, only allow QUIT command */
+if (f.quit_cmd_only)
   return PROXY_FAIL_IGNORE_CMD;
 #endif
 
@@ -2668,11 +2668,20 @@ proxy_session = FALSE;
 /* If valid Proxy Protocol source is connecting, set up session.
 Failure will not allow any SMTP function other than QUIT. */
 
-f.proxy_session_failed = FALSE;
-if (proxy_protocol_host())
+f.quit_cmd_only = FALSE;
+if (hosts_proxy)
   {
-  os_non_restarting_signal(SIGALRM, command_timeout_handler);
-  proxy_protocol_setup();
+  uschar * dummy_errmsg;
+  misc_module_info * mi;
+  typedef BOOL (*fn_t) (void);
+
+  if (!(mi = misc_mod_find(US"proxy", &dummy_errmsg)))
+    {
+    smtp_closedown(US"Temporary local problem - please try later");
+    return FALSE;
+    }
+  if (!((fn_t *) mi->functions)[PROXY_PROTO_START] ())
+    f.quit_cmd_only = TRUE;
   }
 #endif
 

